## refpolicy 2.20140206

=== debian/changelog ===
refpolicy (2:2.20140206-1) unstable; urgency=medium

  * Team upload.
  * New GIT snapshot of the policy
    - Allow unconfined_u user to enter system_r role again (Closes: #732857)
    - Allow unconfined user to transition to dpkg_t and transitively to
      dpkg_script_t (Closes: #707214)
    - Refresh 0004-init-startpar-initrc_t-gets-attributes-of-dev-dm-0-d.patch
    - Drop d/p/0005-add-missing-newline.patch,
      d/p/0006-allow-udev-write-rulesd.patch: Applied upstream
  * debian/selinux-policy-dev.post{inst,rm}: Call sepolgen-ifgen after
    selinux-policy-dev installation if SELinux is enabled
  * debian/selinux-policy-dev.install, debian/rules: Install headers in
    /usr/share/selinux/devel, there is no differences between default and mls
    headers, so it's not necessary to install both.
  * debian/rules, debian/example/Makefile, debian/Makefile.devel: Fix
    development Makefile to work with new headers location
  * debian/control: Bump Standards-Version to 3.9.5 (no further changes)

 -- Laurent Bigonville <bigon@debian.org>  Thu, 06 Feb 2014 21:56:55 +0100

refpolicy (2:2.20131214-1) unstable; urgency=low

  * Team upload.
  [ Laurent Bigonville ]
  * New GIT snapshot of the policy
    - Drop all the Debian specific patches, some of the patches have been
      merged upstream, but the rest was making it really difficult to upgrade
      the policy to the new upstream versions.
    - Add block_suspend access vectors (Closes: #722700)
    - libvirt should now run when compiled with selinux support
      (Closes: #559356)
    - Allow smartd daemon to write in /var/lib/smartmontools directory
      (Closes: #720631)
    - NetworkManager should now be able to write /run/network/ifstate
      (Closes: #711083)
    - Allow dovecot self:process setsched permission (Closes: #716753)
    - Add denyhosts policy package (Closes: #700403)
    - deny_ptrace boolean is now gone (Closes: #691284)
    - Allow fail2ban dac_read_search and dac_override capabilities
      (Closes: #700326)
    - irqbalance has now the getsched permission (Closes: #707243)
  * Refresh debian/modules.conf.* for new release, build all the policy
    packages as modules now
  * Drop debian/file_contexts.subs_dist, install upstream one instead
  * debian/rules: policy/rolemap file is gone
  * debian/control: Bump {build-}dependencies to the last userspace release
  * debian/rules: Disable UBAC for the default policy
  * debian/rules: Build the default policy with UNK_PERMS=allow
  * debian/control: Add dependency against selinux-utils for selinuxenabled
  * debian/NEWS: Add some information about the proper way to permanently
    disable a module
  * d/p/0004-init-startpar-initrc_t-gets-attributes-of-dev-dm-0-d.patch:
    Fix FTBFS and allow startpar can getattr of some devices
  * Add d/p/0005-add-missing-newline.patch: Add missing newline at the end of
    the file, this is causing weird behaviour, thanks M4
  * d/p/0006-allow-udev-write-rulesd.patch: Allow udev to write in
    /etc/udev/rules.d (Closes: #712970)

  [ Mika Pflüger ]
  * debian/postinst.policy: Rewrite the postinst script for the
    selinux-policy-* packages to automatically upgrade the running policy.
    (Closes: #552147)
  * debian/copyright: Update to machine-readable copyright format.
  * debian/postrm.policy: Use common postrm script for selinux-policy-*
    packages.

 -- Laurent Bigonville <bigon@debian.org>  Sun, 15 Dec 2013 22:53:06 +0100

refpolicy (2:2.20110726-13) unstable; urgency=low

  * Team upload.
  [ Mika Pflüger ]
  * Allow dhcpc_t to bind to all udp ports (Closes: #707658).

  [ Laurent Bigonville ]
  * Rework the build system
  * Compress modules files with bzip2
  * debian/control:
    - Bump Standards-Version to 3.9.4 (no further changes)
    - Drop really old Conflicts
    - Add a Breaks against selinux-basics (<< 0.5.2~) so we are sure it
      supports .bz2 compressed modules
  * debian/source/lintian-overrides: Add an override for
    maintainer-script-lacks-debhelper-token

 -- Laurent Bigonville <bigon@debian.org>  Fri, 20 Sep 2013 19:18:57 +0200

refpolicy (2:2.20110726-12) unstable; urgency=low

  * Team upload.
  [ Russel Coker ]
  * Label ~/.adobe(/.*)? as mozilla_home_t for flash
  * Label /usr/sbin/opendkim as dkim_milter_exec_t
  * Label postalias as postfix_master_exec_t for newaliases
  * Make postfix.pp not depend on unconfined.pp for "strict" configurations
  * Label port 5546 as dhcpc_port_t and allow dhcpc_t to bind to TCP for
    client control
  * Label /usr/lib/kde4/libexec/* and /usr/lib/gvfs/* as bin_t for desktops
  * Label /run/pm-utils(/.*)? as devicekit_var_run_t not hald_var_run_t
  * Allow user roles access to mozilla_t classes shm and sem for sharing
    the sound device
  * Allow user roles access to mozilla_tmp_t
  * Label /sbin/xtables-multi (the new iptables)
  * Allow watchdog_t to read syslog pid files for process watching
  * Allow lvm_t (systemd-cryptsetup) systemd_manage_passwd_run() access
  * Allow systemd_passwd_agent_t access to search selinuxfs and write to
    the console for getting a password for encrypted filesystems
  * Label /usr/lib/dovecot/auth as dovecot_auth_exec_t.
    Label /usr/lib/dovecot/dovecot-lda as lda_exec_t
    Label /usr/lib/dovecot/libdovecot.*\.so.* as lib_t
    Closes: #690225

 -- Mika Pflüger <debian@mikapflueger.de>  Fri, 30 Nov 2012 00:28:21 +0100

refpolicy (2:2.20110726-11) unstable; urgency=low

  * Team upload
  [ Mika Pflüger ]
  * Drop incomplete patch adding debian specific gdm3 locations and
    cherry-pick Laurent's complete patch from upstream instead. Slightly
    edit the patch to work around an issue in file context ordering.

 -- Laurent Bigonville <bigon@debian.org>  Sun, 30 Sep 2012 22:43:12 +0200

refpolicy (2:2.20110726-10) unstable; urgency=low

  * Team upload.
  [ Mika Pflüger ]
  * xserver.fc: Add debian specific /usr/sbin/gdm3 as a location for gdm3.
    Closes: #683756
  * debian/control: Update Vcs-* fields.



=== debian/control ===
Source: refpolicy
VCS-Git: git://anonscm.debian.org/selinux/refpolicy.git
VCS-Browser: http://anonscm.debian.org/gitweb/?p=selinux/refpolicy.git;a=summary
Priority: optional
Section: admin
Homepage: http://oss.tresys.com/projects/refpolicy/wiki/DownloadRelease
Maintainer: Debian SELinux maintainers <selinux-devel@lists.alioth.debian.org>
Uploaders: Russell Coker <russell@coker.com.au>
Standards-Version: 3.9.5
Build-Depends: debhelper (>= 9)
Build-Depends-Indep: policycoreutils (>= 2.2.1), checkpolicy (>= 2.2),
                     python, m4, bzip2, gawk, libsepol1 (>= 2.2)

Package: selinux-policy-default
Architecture: all
Depends: ${misc:Depends}, policycoreutils (>= 2.2.1), libpam-modules (>= 0.77-0.se5),
          python, libselinux1 (>= 2.2), libsepol1 (>= 2.2), selinux-utils (>= 2.2.1)
Recommends: checkpolicy, setools
Suggests: logcheck, syslog-summary
Breaks: selinux-basics (<< 0.5.2~)
Description: Strict and Targeted variants of the SELinux policy
 This is the reference policy for SE Linux.  In the default configuration it
 will provide the functionality previously known as the "targeted" policy.  If
 the module "unconfined" is removed then it provides the functionality
 previously known as the "strict" policy.
 .
 This uses the MMCS system of categories.

Package: selinux-policy-mls
Architecture: all
Priority: extra
Depends: ${misc:Depends}, policycoreutils (>= 2.2.1), libpam-modules (>= 0.77-0.se5),
          python, libselinux1 (>= 2.2), libsepol1 (>= 2.2), selinux-utils (>= 2.2.1)
Recommends: checkpolicy, setools
Suggests: logcheck, syslog-summary
Breaks: selinux-basics (<< 0.5.2~)
Description: MLS (Multi Level Security) variant of the SELinux policy
 This is the reference policy for SE Linux built with MLS support.  It allows
 giving data labels such as "Top Secret" and preventing such data from leaking
 to processes or files with lower classification.
 .
 It was developed for Common Criteria LSPP certification for RHEL.  It will
 probably never be well supported in Debian and is only recommended for
 students who want to learn about the security features used by the military.

Package: selinux-policy-src
Architecture: all
Depends: ${misc:Depends}, python, policycoreutils (>= 2.2.1), checkpolicy (>= 2.2), gawk
Recommends: setools
Suggests: logcheck, syslog-summary
Description: Source of the SELinux reference policy for customization
 The SELinux Reference Policy (refpolicy) is a complete SELinux
 policy, as an alternative to the existing strict and targeted
 policies available from http://selinux.sf.net. The goal is to have
 this policy as the system policy, be and used as the basis for
 creating other policies. Refpolicy is based on the current strict and
 targeted policies, but aims to accomplish many additional
 goals:
  + Strong Modularity
  + Clearly stated security Goals
  + Documentation
  + Development Tool Support
  + Forward Looking
  + Configurability
  + Flexible Base Policy
  + Application Policy Variations
  + Multi-Level Security
 .
 This is the source of the policy, provided so that local variations of
 SELinux policy may be created.

Package: selinux-policy-dev
Architecture: all
Depends: ${misc:Depends}, python, policycoreutils (>= 2.2.1), checkpolicy (>= 2.2),
         gawk, make, m4, selinux-utils (>= 2.2)
Recommends: setools
Description: Headers from the SELinux reference policy for building modules
 The SELinux Reference Policy (refpolicy) is a complete SELinux
 policy, as an alternative to the existing strict and targeted
 policies available from http://selinux.sf.net. The goal is to have
 this policy as the system policy, be and used as the basis for
 creating other policies. Refpolicy is based on the current strict and
 targeted policies, but aims to accomplish many additional
 goals:
  + Strong Modularity
  + Clearly stated security Goals
  + Documentation
  + Development Tool Support
  + Forward Looking
  + Configurability
  + Flexible Base Policy
  + Application Policy Variations
  + Multi-Level Security
 .
 This package provides header files for building your own SELinux
 policy packages compatible with official policy packages.

Package: selinux-policy-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Recommends: make, gcc
Conflicts: selinux-policy-refpolicy-doc
Description: Documentation for the SELinux reference policy
 The SELinux Reference Policy (refpolicy) is a complete SELinux
 policy, as an alternative to the existing strict and targeted
 policies available from http://selinux.sf.net. The goal is to have
 this policy as the system policy, be and used as the basis for
 creating other policies. Refpolicy is based on the current strict and
 targeted policies, but aims to accomplish many additional
 goals:
  + Strong Modularity
  + Clearly stated security Goals
  + Documentation
  + Development Tool Support
  + Forward Looking
  + Configurability
  + Flexible Base Policy
  + Application Policy Variations
  + Multi-Level Security
 .
 This package contains the documentation for the reference policy.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

COMMON_OPTIONS = DISTRO=debian DIRECT_INITRC=y MONOLITHIC=n
FLAVOURS = default mls
TYPE_default = mcs
UBAC_default = n
UNK_PERMS_default = allow
TYPE_mls = mls
UBAC_mls = n
UNK_PERMS_mls = deny

%:
	dh $@

override_dh_auto_configure: $(patsubst %, conf-%-policy, $(FLAVOURS)) conf-docs conf-src

override_dh_install:
	dh_install --list-missing

override_dh_fixperms:
	dh_fixperms
	chmod +x $(CURDIR)/debian/selinux-policy-dev/usr/share/selinux/devel/include/support/segenxml.py; \

override_dh_compress:
	dh_compress
	for flavour in $(FLAVOURS) ; do \
	  for f in $(CURDIR)/debian/selinux-policy-$$flavour/usr/share/selinux/$$flavour/*.pp ; do \
	    bzip2 -9f $$f; \
	  done; \
	done

override_dh_installdeb:
	for flavour in $(FLAVOURS) ; do \
	  sed -e "s/=FLAVOUR=/$$flavour/g" debian/postinst.policy > $(CURDIR)/debian/selinux-policy-$$flavour.postinst; \
	  sed -e "s/=FLAVOUR=/$$flavour/g" debian/postrm.policy > $(CURDIR)/debian/selinux-policy-$$flavour.postrm; \
	done
	dh_installdeb

override_dh_clean:
	dh_clean
	$(MAKE) bare
	for flavour in $(FLAVOURS) ; do \
	  rm -f $(CURDIR)/debian/selinux-policy-$$flavour.postinst; \
	  rm -rf $(CURDIR)/debian/build-$$flavour; \
	  rm -f build-$$flavour-policy; \
	  rm -f install-$$flavour-policy; \
	  rm -f conf-$$flavour-policy; \
	done
	rm -f install-default-dev;
	rm -rf $(CURDIR)/debian/build-docs;
	rm -rf $(CURDIR)/debian/build-src;
	rm -f support/pyplate.pyc conf-docs install-docs conf-src install-src

override_dh_auto_build: $(patsubst %, build-%-policy, $(FLAVOURS))

override_dh_auto_install: $(patsubst %, install-%-policy, $(FLAVOURS)) install-default-dev install-docs install-src

conf-%-policy:
	test ! -d $(CURDIR)/debian/build-$* ||                             \
            rm -rf $(CURDIR)/debian/build-$*
	mkdir -p    $(CURDIR)/debian/build-$*
	cp -lr policy support Makefile Rules.modular doc                   \
            Rules.monolithic config VERSION Changelog COPYING INSTALL      \
            README man $(CURDIR)/debian/build-$*
	cp debian/build.conf.$* $(CURDIR)/debian/build-$*/build.conf
	$(MAKE) -C $(CURDIR)/debian/build-$*                               \
                   NAME=$* TYPE=$(TYPE_$*) UBAC=$(UBAC_$*) UNK_PERMS=$(UNK_PERMS_$*) $(COMMON_OPTIONS) bare
	(cd $(SRCTOP)/debian/build-$(package) ;                            \
           $(MAKE) NAME=$* TYPE=$(TYPE_$*) UBAC=$(UBAC_$*) UNK_PERMS=$(UNK_PERMS_$*) $(COMMON_OPTIONS) conf)
	cp debian/modules.conf.$*                                          \
                     $(CURDIR)/debian/build-$*/policy/modules.conf
	touch $@

conf-docs:
	test ! -d $(CURDIR)/debian/build-docs ||                   \
           rm -rf $(CURDIR)/debian/build-docs
	mkdir -p    $(CURDIR)/debian/build-docs
	cp -lr policy support Makefile Rules.modular doc                \
                Rules.monolithic config VERSION Changelog COPYING INSTALL   \
                README man $(CURDIR)/debian/build-docs
	cp  debian/build.conf.default $(CURDIR)/debian/build-docs/build.conf
	(cd $(CURDIR)/debian/build-docs ;                          \
           $(MAKE) NAME=default TYPE=mcs UBAC=n UNK_PERMS=allow $(COMMON_OPTIONS) conf)
	touch $@

conf-src:
	test ! -d $(CURDIR)/debian/build-src ||                  \
	    rm -rf $(CURDIR)/debian/build-src
	mkdir -p    $(CURDIR)/debian/build-src
	cp -lr policy support Makefile Rules.modular  doc               \
	       Rules.monolithic config VERSION Changelog COPYING INSTALL  \
	        README man $(CURDIR)/debian/build-src
	cp  debian/build.conf.default $(CURDIR)/debian/build-src/build.conf
	(cd $(CURDIR)/debian/build-src ;                         \
	   $(MAKE) NAME=default $(OPTIONS) conf)
	cp debian/modules.conf.*      $(CURDIR)/debian/build-src/policy/
	cp debian/build.conf.default $(CURDIR)/debian/build-src/policy/
	touch $@


build-%-policy: conf-%-policy
	(cd $(CURDIR)/debian/build-$* ;                          \
             $(MAKE) NAME=$* TYPE=$(TYPE_$*) UBAC=$(UBAC_$*) UNK_PERMS=$(UNK_PERMS_$*) $(COMMON_OPTIONS) policy)
	touch $@

install-%-policy: build-%-policy
	(cd $(CURDIR)/debian/build-$*; \
	    $(MAKE) NAME=$* TYPE=$(TYPE_$*) UBAC=$(UBAC_$*) UNK_PERMS=$(UNK_PERMS_$*) $(COMMON_OPTIONS) DESTDIR=$(CURDIR)/debian/tmp install \
	    $(CURDIR)/debian/tmp/etc/selinux/$*/users/local.users $(CURDIR)/debian/tmp/etc/selinux/$*/users/system.users)
	cp -a debian/setrans.conf.$* $(CURDIR)/debian/tmp/etc/selinux/$*/setrans.conf
	mkdir -p $(CURDIR)/debian/tmp/etc/selinux/$*/contexts/files/
	mkdir -p $(CURDIR)/debian/tmp/etc/selinux/$*/modules/active/
	touch $(CURDIR)/debian/tmp/etc/selinux/$*/modules/active/file_contexts.local
	mkdir -p $(CURDIR)/debian/tmp/etc/selinux/$*/policy/
	mkdir -p $(CURDIR)/debian/tmp/etc/selinux/$*/modules/
	touch $(CURDIR)/debian/tmp/etc/selinux/$*/modules/semanage.read.LOCK $(CURDIR)/debian/tmp/etc/selinux/$*/modules/semanage.trans.LOCK
	chmod 600 $(CURDIR)/debian/tmp/etc/selinux/$*/modules/semanage.read.LOCK $(CURDIR)/debian/tmp/etc/selinux/$*/modules/semanage.trans.LOCK
	touch $@

# The headers are based on the default policy
install-default-dev: build-default-policy
	(cd $(CURDIR)/debian/build-default; \
	    $(MAKE) NAME=default TYPE=$(TYPE_default) UBAC=$(UBAC_default) UNK_PERMS=$(UNK_PERMS_default) $(COMMON_OPTIONS) DESTDIR=$(CURDIR)/debian/tmp install-headers)
	mkdir -p $(CURDIR)/debian/tmp/usr/share/selinux/devel/
	mv $(CURDIR)/debian/tmp/usr/share/selinux/default/include $(CURDIR)/debian/tmp/usr/share/selinux/devel/
	cp -a $(CURDIR)/debian/Makefile.devel $(CURDIR)/debian/tmp/usr/share/selinux/devel/Makefile
	touch $@

install-docs: conf-docs
	(cd $(CURDIR)/debian/build-docs; \
	    $(MAKE) NAME=default TYPE=mcs UBAC=n UNK_PERMS=allow $(COMMON_OPTIONS) DESTDIR=$(CURDIR)/debian/tmp/ PKGNAME=selinux-policy-doc conf html install-docs)
	touch $@

install-src: conf-src
	mkdir -p    $(CURDIR)/debian/tmp/usr/src
	(cd $(CURDIR)/debian/build-src;                                 \
	 $(MAKE) NAME=default TYPE=mcs UBAC=n UNK_PERMS=allow $(COMMON_OPTIONS) DESTDIR=$(CURDIR)/debian/tmp/ bare conf install-src; )
	find $(CURDIR)/debian/tmp -type d -name .arch-ids -print0 | xargs -0r rm -rf
	test ! -e $(CURDIR)/debian/tmp/etc/selinux/default/src/policy/COPYING || \
	   rm -f $(CURDIR)/debian/tmp/etc/selinux/default/src/policy/COPYING
	rm -rf   $(CURDIR)/debian/tmp/etc/selinux/default/src/policy/man
	(cd $(CURDIR)/debian/tmp/etc/selinux/default/src/policy;                   \
	  if test -f modules.conf; then                                   \
	      mv modules.conf modules.conf.dist;                          \
	  fi;                                                             \
	  ln -sf modules.conf.mls modules.conf)
	install -p -o root -g root -m 644      debian/build.conf.default                   \
	                     $(CURDIR)/debian/tmp/etc/selinux/default/src/policy/build.conf
	(cd $(CURDIR)/debian/tmp/etc/selinux/default/src/; mv policy selinux-policy-src;   \
	                                          rm selinux-policy-src/support/pyplate.pyc; \
	  tar zfc $(CURDIR)/debian/tmp/usr/src/selinux-policy-src.tar.gz selinux-policy-src)
	rm -rf               $(CURDIR)/debian/tmp/etc/selinux/default/src/
	touch $@

=== debian/watch ===
version=3

opts="uversionmangle=s/^2./2./" \
http://oss.tresys.com/projects/refpolicy/wiki/DownloadRelease \
 /files/refpolicy/refpolicy-(.*)\.tar\.bz2

## refpolicy 2.20140421

=== Makefile ===
#
# Makefile for the security policy.
#
# Targets:
# 
# install       - compile and install the policy configuration, and context files.
# load          - compile, install, and load the policy configuration.
# reload        - compile, install, and load/reload the policy configuration.
# relabel       - relabel filesystems based on the file contexts configuration.
# checklabels   - check filesystems against the file context configuration
# restorelabels - check filesystems against the file context configuration
#                 and restore the label of files with incorrect labels
# policy        - compile the policy configuration locally for testing/development.
#
# The default target is 'policy'.
#
#
# Please see build.conf for policy build options.
#

########################################
#
# NO OPTIONS BELOW HERE
#

# Include the local build.conf if it exists, otherwise
# include the configuration of the root directory.
include build.conf

ifdef LOCAL_ROOT
	-include $(LOCAL_ROOT)/build.conf
endif

# refpolicy version
version = $(shell cat VERSION)

ifdef LOCAL_ROOT
builddir := $(LOCAL_ROOT)/
tmpdir := $(LOCAL_ROOT)/tmp
tags := $(LOCAL_ROOT)/tags
else
tmpdir := tmp
tags := tags
endif

# executable paths
BINDIR ?= /usr/bin
SBINDIR ?= /usr/sbin
ifdef TEST_TOOLCHAIN
tc_usrbindir := env LD_LIBRARY_PATH="$(TEST_TOOLCHAIN)/lib:$(TEST_TOOLCHAIN)/usr/lib" $(TEST_TOOLCHAIN)$(BINDIR)
tc_usrsbindir := env LD_LIBRARY_PATH="$(TEST_TOOLCHAIN)/lib:$(TEST_TOOLCHAIN)/usr/lib" $(TEST_TOOLCHAIN)$(SBINDIR)
tc_sbindir := env LD_LIBRARY_PATH="$(TEST_TOOLCHAIN)/lib:$(TEST_TOOLCHAIN)/usr/lib" $(TEST_TOOLCHAIN)/sbin
else
tc_usrbindir := $(BINDIR)
tc_usrsbindir := $(SBINDIR)
tc_sbindir := /sbin
endif
CHECKPOLICY ?= $(tc_usrbindir)/checkpolicy
CHECKMODULE ?= $(tc_usrbindir)/checkmodule
SEMODULE ?= $(tc_usrsbindir)/semodule
SEMOD_PKG ?= $(tc_usrbindir)/semodule_package
SEMOD_LNK ?= $(tc_usrbindir)/semodule_link
SEMOD_EXP ?= $(tc_usrbindir)/semodule_expand
LOADPOLICY ?= $(tc_usrsbindir)/load_policy
SETFILES ?= $(tc_sbindir)/setfiles
XMLLINT ?= $(BINDIR)/xmllint
SECHECK ?= $(BINDIR)/sechecker

# interpreters and aux tools
AWK ?= gawk
GREP ?= egrep
INSTALL ?= install
M4 ?= m4
PYTHON ?= python
SED ?= sed
SORT ?= LC_ALL=C sort
UMASK ?= umask

CFLAGS += -Wall

# policy source layout
poldir := policy
moddir := $(poldir)/modules
flaskdir := $(poldir)/flask
secclass := $(flaskdir)/security_classes
isids := $(flaskdir)/initial_sids
avs := $(flaskdir)/access_vectors

# local source layout
ifdef LOCAL_ROOT
local_poldir := $(LOCAL_ROOT)/policy
local_moddir := $(local_poldir)/modules
endif

# policy building support tools
support := support
genxml := $(PYTHON) -E $(support)/segenxml.py
gendoc := $(PYTHON) -E $(support)/sedoctool.py
genperm := $(PYTHON) -E $(support)/genclassperms.py
policyvers := $(PYTHON) -E $(support)/policyvers.py
fcsort := $(tmpdir)/fc_sort
setbools := $(AWK) -f $(support)/set_bools_tuns.awk
get_type_attr_decl := $(SED) -r -f $(support)/get_type_attr_decl.sed
comment_move_decl := $(SED) -r -f $(support)/comment_move_decl.sed
gennetfilter := $(PYTHON) -E $(support)/gennetfilter.py
m4iferror := $(support)/iferror.m4
m4divert := $(support)/divert.m4
m4undivert := $(support)/undivert.m4
# use our own genhomedircon to make sure we have a known usable one,
# so policycoreutils updates are not required (RHEL4)
genhomedircon := $(PYTHON) -E $(support)/genhomedircon

# documentation paths
docs := doc
xmldtd = $(docs)/policy.dtd
metaxml = metadata.xml
doctemplate = $(docs)/templates
docfiles = $(docs)/Makefile.example $(addprefix $(docs)/,example.te example.if example.fc)

ifndef LOCAL_ROOT
polxml = $(docs)/policy.xml
tunxml = $(docs)/global_tunables.xml
boolxml = $(docs)/global_booleans.xml
htmldir = $(docs)/html
else
polxml = $(LOCAL_ROOT)/doc/policy.xml
tunxml = $(LOCAL_ROOT)/doc/global_tunables.xml
boolxml = $(LOCAL_ROOT)/doc/global_booleans.xml
htmldir = $(LOCAL_ROOT)/doc/html
endif

# config file paths
globaltun = $(poldir)/global_tunables
globalbool = $(poldir)/global_booleans
user_files := $(poldir)/users
policycaps := $(poldir)/policy_capabilities

# local config file paths
ifndef LOCAL_ROOT
mod_conf = $(poldir)/modules.conf
booleans = $(poldir)/booleans.conf
tunables = $(poldir)/tunables.conf
else
mod_conf = $(local_poldir)/modules.conf
booleans = $(local_poldir)/booleans.conf
tunables = $(local_poldir)/tunables.conf
endif

# install paths
PKGNAME ?= refpolicy-$(version)
prefix = $(DESTDIR)/usr
topdir = $(DESTDIR)/etc/selinux
installdir = $(topdir)/$(strip $(NAME))
srcpath = $(installdir)/src
userpath = $(installdir)/users
policypath = $(installdir)/policy
contextpath = $(installdir)/contexts
homedirpath = $(contextpath)/files/homedir_template
fcpath = $(contextpath)/files/file_contexts
fcsubspath = $(contextpath)/files/file_contexts.subs_dist
ncpath = $(contextpath)/netfilter_contexts
sharedir = $(prefix)/share/selinux
modpkgdir = $(sharedir)/$(strip $(NAME))
headerdir = $(modpkgdir)/include
docsdir = $(prefix)/share/doc/$(PKGNAME)

# enable MLS if requested.
ifeq "$(TYPE)" "mls"
	M4PARAM += -D enable_mls
	CHECKPOLICY += -M
	CHECKMODULE += -M
	gennetfilter += -m
endif

# enable MLS if MCS requested.
ifeq "$(TYPE)" "mcs"
	M4PARAM += -D enable_mcs
	CHECKPOLICY += -M
	CHECKMODULE += -M
	gennetfilter += -c
endif

# enable distribution-specific policy
ifneq ($(DISTRO),)
	M4PARAM += -D distro_$(DISTRO)
endif

# rhel4 also implies redhat
ifeq "$(DISTRO)" "rhel4"
	M4PARAM += -D distro_redhat
endif

ifeq "$(DISTRO)" "ubuntu"
	M4PARAM += -D distro_debian
endif

ifneq ($(OUTPUT_POLICY),)
	CHECKPOLICY += -c $(OUTPUT_POLICY)
endif

ifneq "$(CUSTOM_BUILDOPT)" ""
	M4PARAM += $(foreach opt,$(CUSTOM_BUILDOPT),-D $(opt))
endif

# if not set, use the type as the name.
NAME ?= $(TYPE)

# default unknown permissions setting
#UNK_PERMS ?= deny

ifeq ($(DIRECT_INITRC),y)
	M4PARAM += -D direct_sysadm_daemon
endif

ifeq "$(UBAC)" "y"
	M4PARAM += -D enable_ubac
endif

# default MLS/MCS sensitivity and category settings.
MLS_SENS ?= 16
MLS_CATS ?= 1024
MCS_CATS ?= 1024

ifeq ($(QUIET),y)
	verbose = @
endif

M4PARAM += -D mls_num_sens=$(MLS_SENS) -D mls_num_cats=$(MLS_CATS) -D mcs_num_cats=$(MCS_CATS) -D hide_broken_symptoms

# we need exuberant ctags; unfortunately it is named
# differently on different distros
ifeq ($(DISTRO),debian)
	CTAGS := ctags-exuberant
endif

ifeq ($(DISTRO),gentoo)
	CTAGS := exuberant-ctags	
endif

CTAGS ?= ctags

m4support := $(m4divert) $(wildcard $(poldir)/support/*.spt)
ifdef LOCAL_ROOT
m4support += $(wildcard $(local_poldir)/support/*.spt)
endif
m4support += $(m4undivert)

appconf := config/appconfig-$(TYPE)
seusers := $(appconf)/seusers
appdir := $(contextpath)
user_default_contexts := $(wildcard config/appconfig-$(TYPE)/*_default_contexts)
user_default_contexts_names := $(addprefix $(contextpath)/users/,$(subst _default_contexts,,$(notdir $(user_default_contexts))))
appfiles := $(addprefix $(appdir)/,default_contexts default_type initrc_context failsafe_context userhelper_context removable_context dbus_contexts sepgsql_contexts x_contexts customizable_types securetty_types virtual_domain_context virtual_image_context) $(contextpath)/files/media $(fcsubspath) $(user_default_contexts_names)
net_contexts := $(builddir)net_contexts

all_layers := $(shell find $(wildcard $(moddir)/*) -maxdepth 0 -type d)
ifdef LOCAL_ROOT
all_layers += $(shell find $(wildcard $(local_moddir)/*) -maxdepth 0 -type d)
endif

generated_te := $(basename $(foreach dir,$(all_layers),$(wildcard $(dir)/*.te.in)))
generated_if := $(basename $(foreach dir,$(all_layers),$(wildcard $(dir)/*.if.in)))
generated_fc := $(basename $(foreach dir,$(all_layers),$(wildcard $(dir)/*.fc.in)))

# sort here since it removes duplicates, which can happen
# when a generated file is already generated
detected_mods := $(sort $(foreach dir,$(all_layers),$(wildcard $(dir)/*.te)) $(generated_te))

modxml := $(addprefix $(tmpdir)/, $(detected_mods:.te=.xml))
layerxml := $(sort $(addprefix $(tmpdir)/, $(notdir $(addsuffix .xml,$(all_layers)))))
layer_names := $(sort $(notdir $(all_layers)))
all_metaxml = $(call detect-metaxml, $(layer_names))

# modules.conf setting for base module
configbase := base

# modules.conf setting for loadable module
configmod := module

# modules.conf setting for unused module
configoff := off

# test for module overrides from command line
mod_test = $(filter $(APPS_OFF), $(APPS_BASE) $(APPS_MODS))
mod_test += $(filter $(APPS_MODS), $(APPS_BASE))
ifneq "$(strip $(mod_test))" ""
        $(error Applications must be base, module, or off, and not in more than one list! $(strip $(mod_test)) found in multiple lists!)
endif

# add on suffix to modules specified on command line
cmdline_base := $(addsuffix .te,$(APPS_BASE))
cmdline_mods := $(addsuffix .te,$(APPS_MODS))
cmdline_off := $(addsuffix .te,$(APPS_OFF))

# extract settings from modules.conf
mod_conf_base := $(addsuffix .te,$(sort $(shell awk '/^[[:blank:]]*[[:alpha:]]/{ if ($$3 == "$(configbase)") print $$1 }' $(mod_conf) 2> /dev/null)))
mod_conf_mods := $(addsuffix .te,$(sort $(shell awk '/^[[:blank:]]*[[:alpha:]]/{ if ($$3 == "$(configmod)") print $$1 }' $(mod_conf) 2> /dev/null)))
mod_conf_off := $(addsuffix .te,$(sort $(shell awk '/^[[:blank:]]*[[:alpha:]]/{ if ($$3 == "$(configoff)") print $$1 }' $(mod_conf) 2> /dev/null)))

base_mods := $(cmdline_base)
mod_mods := $(cmdline_mods)
off_mods := $(cmdline_off)

base_mods += $(filter-out $(cmdline_off) $(cmdline_base) $(cmdline_mods), $(mod_conf_base))
mod_mods += $(filter-out $(cmdline_off) $(cmdline_base) $(cmdline_mods), $(mod_conf_mods))
off_mods += $(filter-out $(cmdline_off) $(cmdline_base) $(cmdline_mods), $(mod_conf_off))

# add modules not in modules.conf to the off list
off_mods += $(filter-out $(base_mods) $(mod_mods) $(off_mods),$(notdir $(detected_mods)))

# filesystems to be used in labeling targets
filesystems = $(shell mount | grep -v "context=" | egrep -v '\((|.*,)bind(,.*|)\)' | awk '/(ext[234]|btrfs| xfs| jfs).*rw/{print $$3}';)
fs_names := "btrfs ext2 ext3 ext4 xfs jfs"

########################################
#
# Functions
#

# detect-metaxml layer_names
ifdef LOCAL_ROOT
define detect-metaxml
	$(shell for i in $1; do \
		if [ -d $(moddir)/$$i -a -d $(local_moddir)/$$i ]; then \
			if [ -f $(local_moddir)/$$i/$(metaxml) ]; then \
				echo $(local_moddir)/$$i/$(metaxml) ;\
			else \
				echo $(moddir)/$$i/$(metaxml) ;\
			fi \
		elif [ -d $(local_moddir)/$$i ]; then
			echo $(local_moddir)/$$i/$(metaxml) ;\
		else \
			echo $(moddir)/$$i/$(metaxml) ;\
		fi \
	done )
endef
else
define detect-metaxml
	$(shell for i in $1; do echo $(moddir)/$$i/$(metaxml); done)
endef
endif

########################################
#
# Load appropriate rules
#

ifeq ($(MONOLITHIC),y)
	include Rules.monolithic
else
	include Rules.modular
endif

########################################
#
# Generated files
#
# NOTE: There is no "local" version of these files.
#
generate: $(generated_te) $(generated_if) $(generated_fc)

$(moddir)/kernel/corenetwork.if: $(moddir)/kernel/corenetwork.te.in $(moddir)/kernel/corenetwork.if.m4 $(moddir)/kernel/corenetwork.if.in
	@echo "#" > $@
	@echo "# This is a generated file!  Instead of modifying this file, the" >> $@
	@echo "# $(notdir $@).in or $(notdir $@).m4 file should be modified." >> $@
	@echo "#" >> $@
	$(verbose) cat $@.in >> $@
	$(verbose) $(GREP) "^[[:blank:]]*network_(interface|node|port|packet)(_controlled)?\(.*\)" $< \
		| $(M4) -D self_contained_policy $(M4PARAM) $(m4divert) $@.m4 $(m4undivert) - \
		| $(SED) -e 's/dollarsone/\$$1/g' -e 's/dollarszero/\$$0/g' >> $@

$(moddir)/kernel/corenetwork.te: $(m4divert) $(moddir)/kernel/corenetwork.te.m4 $(m4undivert) $(moddir)/kernel/corenetwork.te.in
	@echo "#" > $@
	@echo "# This is a generated file!  Instead of modifying this file, the" >> $@
	@echo "# $(notdir $@).in or $(notdir $@).m4 file should be modified." >> $@
	@echo "#" >> $@
	$(verbose) $(M4) -D self_contained_policy $(M4PARAM) $^ \

=== debian/changelog ===
refpolicy (2:2.20140421-9) unstable; urgency=medium

  * Allow dovecot_t to read /usr/share/dovecot/protocols.d
    Allow dovecot_t capability sys_resource
    Label /usr/lib/dovecot/* as bin_t unless specified otherwise
    Allow dovecot_auth_t to manage dovecot_var_run_t for auth tokens
  * Allow clamd_t capability { chown fowner fsetid }
    Allow clamd_t to read sysctl_vm_t
  * Allow dkim_milter_t capability dac_override and read sysctl_vm_t
    allow dkim_milter_t to bind to unreserved UDP ports
  * Label all hard-links of perdition perdition_exec_t
    Allow perdition to read /dev/urandom and capabilities dac_override, chown,
    and fowner
    Allow perdition file trans to perdition_var_run_t for directories
    Also proxy the sieve service - sieve_port_t
    Allow connecting to mysql for map data
  * Allow nrpe_t to read nagios_etc_t and have capability dac_override
  * Allow httpd_t to write to initrc_tmp_t files
    Label /var/lib/php5(/.*)? as httpd_var_lib_t
  * Allow postfix_cleanup_t to talk to the dkim filter
    allow postfix_cleanup_t to use postfix_smtpd_t fds (for milters)
    allow postfix_smtpd_t to talk to clamd_t via unix sockets
    allow postfix_master_t to execute hostname for Debian startup scripts
  * Allow unconfined_cronjob_t role system_r and allow it to restart daemons
    via systemd
    Allow system_cronjob_t to unlink httpd_var_lib_t files (for PHP session
    cleanup)
  * Allow spamass_milter_t to search the postfix spool and sigkill itself
    allow spamc_t to be in system_r for when spamass_milter runs it
  * Allow courier_authdaemon_t to execute a shell
  * Label /usr/bin/maildrop as procmail_exec_t
    Allow procmail_t to connect to courier authdaemon for the courier maildrop,
    also changed courier_stream_connect_authdaemon to use courier_var_run_t
    for the type of the socket file
    Allow procmail_t to read courier config for maildrop.
  * Allow system_mail_t to be in role unconfined_r
  * Label ldconfig.real instead of ldconfig as ldconfig_exec_t
  * Allow apt_t to list directories of type apt_var_log_t
  * Allow dpkg_t to execute dpkg_tmp_t and load kernel modules for
    dpkg-preconfigure
  * Allow dpkg_script_t to create udp sockets, netlink audit sockets, manage
    shadow files, process setfscreate, and capabilities audit_write net_admin
    sys_ptrace
  * Label /usr/lib/xen-*/xl as xm_exec_t

 -- Russell Coker <russell@coker.com.au>  Fri, 06 Feb 2015 02:31:05 +1100

refpolicy (2:2.20140421-8) unstable; urgency=medium

  * Make all of /etc/ssl apart from /etc/ssl/private etc_t
  * Allow systemd_logind_t to search xdm_tmp_t:dir
    Allow systemd_tmpfiles_t to create xdm_tmp_t:dir
    Make xserver_create_xdm_tmp_socket also allow unlinking the socket
    Allow systemd_tmpfiles_t to create xdm_tmp_t dir
    Allow systemd_logind_t to search xdm_tmp_t
    Allow system_dbusd_t to write to systemd_logind_var_run_t:fifo_file
    for /run/systemd/inhibit/*.ref also added fc for /run/systemd/inhibit
    Allow system_dbusd_t to write to /run/systemd/inhibit/* pipes
    Allow user_t to talk to user_dbusd_t via unix sockets and also all
    dbus clients
    Allow systemd_tmpfiles_t to create xfs_tmp_t dirs
    Closes: #771482
  * Allow userdomains netlink_audit_socket access for logging of X unlock
  * Allow $1_user_ssh_agent_t to send sigchld to xdm_t
  * Allow local_login_t to write to systemd sessions pipes
  * Allow policykit_t to read /run/systemd/machines and /run/systemd/seats/*
  * Allow init_status() for user domains for kdeinit
  * Remove most of the gpg stuff that I put in 2:2.20140421-7.
    Just remove gpg_helper_t, merge gpg_pinentry_t with the main gpg domain,
    and make the gpg_t domain only used from user_t. Domain trans from
    gpg_agent_t to user_t when running bin_t such as ck-launch-session.
    Allow gpg_agent_t and *_ssh_agent_t to append to an inherited user_home_t
    file
    Closes: #771484
  * Allow user_dbusd_t to append to user_home_t
  * Allow load_policy_t to read /dev/urandom.
  * Label /usr/lib/dovecot/(log)|(ssl-params)|(anvil) dovecot_exec_t so they
    can be executed by the main dovecot daemon.
    Closes: #775223
  * Allow alsa_t to create lockfiles and added fc for
    /run/lock/asound.state.lock
  * Allow local_login_t capability net_admin
  * Allow systemd_logind_t capability sys_admin and mount tmpfs_t
  * Allow mozilla_t (Chrome) to manage symlinks in /tmp and create sockets
    Allow chrome_sandbox_t to use user_t fd.
    Allow mozilla_t to use netlink_kobject_uevent_socket.
    Label ~/.config/google-chrome as mozilla_home_t
    Label /opt/google/chrome/nacl_helper as chrome_browser_exec_t
    Allow chrome_sandbox_t to write to users pty (for startup error messages)
    Closes: #771483
  * Allow userdomains to read vm sysctls and to create a
    netlink_kobject_uevent_socket.
  * Allow initrc_t to perform systemd service start/stop operations on
    initrc_var_run_t files. This may be a bug in systemd.
  * Label .xsession-errors as user_home_t when xdm_t creates it.
  * Label /usr/sbin/dhcp6c as dhcpc_exec_t /run/dhcp6c.pid as dhcpc_var_run_t
    and /var/lib/dhcpv6 as dhcpc_state_t
  * Dontaudit getty_t capability sys_admin
  * Allow cronjob_t read-write access to crond_tmp_t.
  * Allow gconfd_t to read /var/lib/gconf/defaults and /proc/filesystems
  * Allow fsadm_t to stat mount_var_run_t for /run/mount/utab

 -- Russell Coker <russell@coker.com.au>  Mon, 19 Jan 2015 16:27:05 +1100

refpolicy (2:2.20140421-7) unstable; urgency=medium

  * Label /run/systemd/journal/dev-log and /run/systemd/journal/stdout as
    devlog_t
  * Allow bootloadter_t to load kernel modules and run apt-cache
  * Allow systemd_cgroups_t to read /proc/cmdline
  * Allow sshd net_admin capability
  * Allow systemd_logind_t to read kernel sysctls, list tmpfs, and mount on
    /var/auth, and systemd_unit_file_t:service stop.
  * Allow dpkg_script_t to restart systemd unit files of type init_var_run_t


=== debian/rules ===
--- 
+++ 
@@ -42,6 +42,7 @@
 	$(MAKE) bare
 	for flavour in $(FLAVOURS) ; do \
 	  rm -f $(CURDIR)/debian/selinux-policy-$$flavour.postinst; \
+	  rm -f $(CURDIR)/debian/selinux-policy-$$flavour.postrm; \
 	  rm -rf $(CURDIR)/debian/build-$$flavour; \
 	  rm -f build-$$flavour-policy; \
 	  rm -f install-$$flavour-policy; \
@@ -66,7 +67,7 @@
 	cp debian/build.conf.$* $(CURDIR)/debian/build-$*/build.conf
 	$(MAKE) -C $(CURDIR)/debian/build-$*                               \
                    NAME=$* TYPE=$(TYPE_$*) UBAC=$(UBAC_$*) UNK_PERMS=$(UNK_PERMS_$*) $(COMMON_OPTIONS) bare
-	(cd $(SRCTOP)/debian/build-$(package) ;                            \
+	(cd $(CURDIR)/debian/build-$* ;                            \
            $(MAKE) NAME=$* TYPE=$(TYPE_$*) UBAC=$(UBAC_$*) UNK_PERMS=$(UNK_PERMS_$*) $(COMMON_OPTIONS) conf)
 	cp debian/modules.conf.$*                                          \
                      $(CURDIR)/debian/build-$*/policy/modules.conf
@@ -124,6 +125,8 @@
 	    $(MAKE) NAME=default TYPE=$(TYPE_default) UBAC=$(UBAC_default) UNK_PERMS=$(UNK_PERMS_default) $(COMMON_OPTIONS) DESTDIR=$(CURDIR)/debian/tmp install-headers)
 	mkdir -p $(CURDIR)/debian/tmp/usr/share/selinux/devel/
 	mv $(CURDIR)/debian/tmp/usr/share/selinux/default/include $(CURDIR)/debian/tmp/usr/share/selinux/devel/
+	grep -v genfscon.selinuxfs $(CURDIR)/debian/tmp/usr/share/selinux/devel/include/kernel/selinux.if > $(CURDIR)/debian/tmp/usr/share/selinux/devel/include/kernel/selinux.if.new
+	mv $(CURDIR)/debian/tmp/usr/share/selinux/devel/include/kernel/selinux.if.new $(CURDIR)/debian/tmp/usr/share/selinux/devel/include/kernel/selinux.if
 	cp -a $(CURDIR)/debian/Makefile.devel $(CURDIR)/debian/tmp/usr/share/selinux/devel/Makefile
 	touch $@
